 /**
 * @author: Mari Carmen Otero
 */

package junio;

import javabook.*;

class CtaBancaria
{
    //atributos
    private MainWindow ventanaPrincipal;
    private InputBox cuadroEntrada;
    private OutputBox cuadroSalida;
    private MessageBox cuadroMensaje;
    private ResponseBox cuadroRespuesta;
    private String entidadBancaria;
    private String oficinaBancaria;
    private String numeroCuenta;

    //constructor
    public CtaBancaria()
    {
        ventanaPrincipal = new MainWindow();
      	cuadroEntrada = new InputBox (ventanaPrincipal);
      	cuadroSalida = new OutputBox (ventanaPrincipal);
      	cuadroMensaje = new MessageBox (ventanaPrincipal);
      	cuadroRespuesta = new ResponseBox (ventanaPrincipal);
        entidadBancaria = new String();
        oficinaBancaria = new String();
        numeroCuenta = new String();
                
      	ventanaPrincipal.setVisible(true);
      	cuadroSalida.show();
    }

    //mtodo empezar
    public void empezar()
    {
      	int respuesta;
      	respuesta = cuadroRespuesta.prompt("Quieres validar datos de una cuenta bancaria?");

      	while (respuesta == cuadroRespuesta.YES)
      	{
          	leerEntidad();
          	leerOficina();
          	leerDigitoControlyNumeroCuenta();

          	mostrarDatosCuentaCorrecta();

          	respuesta = cuadroRespuesta.prompt("Quieres validar ms cuentas bancarias?");
      	}
    }

    //mtodo leerEntidad
    private void leerEntidad()
    {
        boolean esLongitudCorrecta = true;
        boolean esNumerica = true;

        do
        {
            entidadBancaria = cuadroEntrada.getString ("Introduce la entidad bancaria: ");
            String cad = new String(entidadBancaria);

            esLongitudCorrecta = validarLongitud(cad);
            if (esLongitudCorrecta == false)
                cuadroMensaje.show("La longitud de la entidad bancaria debe ser 4. Repetir");

            esNumerica = validarDigitosNumericos(cad);
            if (esNumerica == false)
                cuadroMensaje.show("Los dgitos de la entidad bancaria deben ser numricos. Repetir");
            
        } while (!esLongitudCorrecta || !esNumerica);
    }

    //mtodo leerOficina
    private void leerOficina()
    {
        boolean esLongitudCorrecta = true;
        boolean esNumerica = true;

        do
        {
            oficinaBancaria = cuadroEntrada.getString ("Introduce la oficina bancaria: ");
            String cad = new String(oficinaBancaria);

            esLongitudCorrecta = validarLongitud(cad);
            if (esLongitudCorrecta == false)
                cuadroMensaje.show("La longitud de la oficina bancaria debe ser 4. Repetir");

            esNumerica = validarDigitosNumericos(cad);
            if (esNumerica == false)
                cuadroMensaje.show("Los dgitos de la oficina bancaria deben ser numricos. Repetir");
            
        } while (!esLongitudCorrecta || !esNumerica);
    }

  	//mtodo validarLongitud
  	private boolean validarLongitud(String cadena)
  	{
        boolean esCorrecto = true;
        if (cadena.length() != 4)
            esCorrecto = false;
        return esCorrecto;
    }

    //mtodo validarDigitosNumericos
    private boolean validarDigitosNumericos(String cadena)
    {
        int i = 0;
        boolean cadenaNumerica = true;
  
        while (i < cadena.length() && cadenaNumerica)
        {
            if (cadena.charAt(i) < '0' || cadena.charAt(i) > '9')
                cadenaNumerica = false;
            else
                i++;
        }
        return cadenaNumerica;
    }

    //mtodo leerDigitoControlyNumeroCuenta
    private void leerDigitoControlyNumeroCuenta()
    {
        int digitoControl = 0, digitoControlCalculado = 0;
        do
      	{
            digitoControl = cuadroEntrada.getInteger("Teclea el dgito de control (DC 2 dgitos numricos): ");
            numeroCuenta = cuadroEntrada.getString("Teclea el nmero de cuenta (10 dgitos): ");
            digitoControlCalculado = calcularDigitoCuenta();
            if (digitoControl != digitoControlCalculado)
                cuadroMensaje.show("El DC calculado no coincide con el DC tecleado.Repetir");
  	   	} while (digitoControl != digitoControlCalculado);
  	}

  	//mtodo calcularDigitoCuenta
  	private int calcularDigitoCuenta()
  	{
        int suma = 0, numero = 21;
        for (int i = 0; i < numeroCuenta.length(); i++) 
        {
            suma = suma + numero * Integer.parseInt(String.valueOf(numeroCuenta.charAt(i)));
            numero = numero - 2;
        }
        return suma % 100;
    }

    //mtodo mostrarDatosCuentaCorrecta
    private void mostrarDatosCuentaCorrecta()
    {
      cuadroSalida.printLine ("Entidad Bancaria:  " + entidadBancaria);
      cuadroSalida.printLine ("Oficina Bancaria:  " + oficinaBancaria);
      cuadroSalida.printLine ("Nmero de cuenta:  " + numeroCuenta);
      cuadroSalida.printLine ("Dgito de control: " + calcularDigitoCuenta());
    }

}